function ind = CDTUCB(reward, pulls, tt)

n_arms = size(reward, 2);
m = 30;
h = 8;
alpha = 0.01;
epsilon = 0.03;

persistent gplus
persistent gminus
persistent last_change
persistent bar_mu

if isempty(gplus)
    gplus = zeros(1, n_arms);
    gminus = zeros(1, n_arms);
    last_change = ones(1, n_arms);
    bar_mu = zeros(1, n_arms);
end

% Reset CDT if necessary
trigger = gplus > h | gminus > h;
last_change(trigger) = tt;
gplus(trigger) = 0;
gminus(trigger) = 0;

% Compute the pulls for each arm
avail_pulls = zeros(1, n_arms);
for ii = 1:n_arms
    avail_pulls(ii) = sum(pulls(last_change(ii):tt, ii));
end

% Check if an arm has less than m pulls, if so pull it
if 
    %%
else
    % Compute bar_mu for all the arms having exactly m pulls

    % Update the CDT using the last reward generated

    % Pull arms according to UCB with probability 1-\alpha

end
