clear;
clear CDTUCB.m
clc;
close all;
addpath(genpath('.'));

%% Mab stochastic environment

R = [0.2 0.3 0.7 0.5; ...
    0.1 0.2 0.4 0.6; ...
    0.9 0.5 0.7 0.1; ...
    0.3 0.4 0.5 0.8];


T = 3000;
breakpoints = [1000 1500 2000];

plot_evolution(R, breakpoints, T);

n_arms = length(R);

% UCB1
pulls = zeros(T, n_arms);
reward = zeros(T, n_arms);

fig = figure();
ind = zeros(T,1);
rewards = zeros(T,1);

for tt = 1:T
    % Algortithm choice
    %ind(tt) = UCB1(reward, pulls, tt);
    ind(tt) = TS(reward, pulls, tt);
    %ind(tt) = SW_TS(reward, pulls, tt, T);
    ind(tt) = CDTUCB(reward, pulls, tt);
    
    %Plot bounds
    %fig = plot_UCB1bound(fig, T, tt, cum_r, N, R, ind(tt));
    
    %Reward
    %rewards(tt) = stochastic_env(R, ind(tt));
    rewards(tt) = stochastic_nonst_env(R, breakpoints, tt, ind(tt));
    
    %Update statistics
    pulls(tt, ind(tt)) = pulls(tt, ind(tt)) + 1;
    reward(tt, ind(tt)) = reward(tt, ind(tt)) + rewards(tt);
end

%% Plot Pseudo Regret

breakpoints = [0 breakpoints T];
%breakpoints = [0 T];

n_phase = length(breakpoints);
for ii = 1:(n_phase-1)
    tt_ind = (breakpoints(ii)+1):breakpoints(ii+1);
    exp_rew = R(ii, :);
    pseudo_regret(tt_ind) = max(exp_rew) - exp_rew(ind(tt_ind));
end

plot(cumsum(pseudo_regret));
